import re,urllib.request
from bs4 import BeautifulSoup
from urllib.parse import quote
import os,sys

def tryUrlOpen(url):
    headers = {'User-Agent':'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:23.0) Gecko/20100101 Firefox/23.0'}  
    req = urllib.request.Request(url=url, headers=headers)
    content = urllib.request.urlopen(req,timeout=5).read()
    return content

def urlBS(url):
	content = ""
	try:
		content = tryUrlOpen(url)
	except Exception:
		print("网络访问超时,请重试")
		os.system('pause')
		sys.exit()
	soup = BeautifulSoup(content,"lxml")
	return soup

def get_source_url():
    base_url='http://www.soed2k.com/find?kw='
    key_words=input('请输入想要搜索的电影名字：\n')
    key_words=quote(key_words)
    source_url=base_url+key_words
    return source_url

def get_child_url(url):
    links = []
    soup=urlBS(url)
    all_links = soup.find_all('div',{'class':'item-title'})
    for link in all_links:
        single = link.find('a')
        links.append('http://www.soed2k.com'+single['href'])
    return links

def write_info(url):
    soup = urlBS(url)
    content = soup.find_all(attrs={"name":"description"})
    title = ""
    if content[0]:
        title = content[0].get("content")
    download_link_tip = soup.find('div',{'class':'panel-body'})
    download_link = download_link_tip.find('a')['href']
    
    arr = soup.find_all('table',{'class':'detail-table detail-width'})
    size = ""
    for tds in arr:
        sizeTd = tds.find_all('td')
        size = sizeTd[4].text.strip()
    # print(size)
    print("----找到电影:",title,"-----------")
    f.write('---------------------------------------------------------------------\n')
    f.write(title+'\n\n'+"大小:"+size+'\n\n'+"下载地址:"+download_link+'\n\n')

if __name__=='__main__':
    source_url=get_source_url()
    print("获取链接。。")
    f=open("movies.txt", "w",encoding="utf-8")
    links = get_child_url(source_url)
    cur = 0
    count = 0
    if int(len(links)) == 15:
        count = int(len(links) / 3)
    else:
        count = int(len(links))

    for linkpage in links:
        if cur == 0:
            print('正在下载，请稍候。。。\n\n')
        write_info(linkpage)
        cur+=1
        if cur==count :
            break
    f.close()
    if cur == 0 :
        print("未找到该电影链接,按任意键退出")
    else:
        print("数据写入完毕,按任意键退出")
    os.system('pause')
